crm/urls.py
from django.urls import path
from django.conf import settings
from django.conf.urls import include, url

from .views import (abonement, client, group, index, login, logout, promotion,
                    source_of_attraction, tutor, sale)
from .views.calendar.api.preentry_visits import CreatePreEntryVisitView, DeletePreEntryVisitView, GetPreEntryGroupByUser
from .views.client_information import abonement as info_abonement
from .views.client_information import history as info_history
from .views.client_information import installment
from .views.client_information.information import InformationView
from .views.settings import departaments
from crm.views.settings.rbac import users, groups
from crm.views.client_information.installment import (InstallmentPaymentsView,
                                                    InstallmentPaymentsCreate,
                                                    AjaxValidatePaymentMoney,
                                                    AjaxForceClosePayment,
                                                      DeletePaymentAjax)
from crm.views import revoke_abonement
from crm.views.calendar.calendar import CalendarView, CalendarAddVisitsView
from crm.views.calendar.api.tutor import CalendarDayView
from crm.views.calendar.api.client import ClientApiView, GetAbonementsByClient, CheckClientSubscriptionInGroup
from crm.views.calendar.api.schedule import ScheduleByDayView
from crm.views.calendar.api.visits import CreateVisitsView, DestroyVisitsView, GetVisitsByGroupAndDate
from crm.views.calendar.api.preentry_visits import GetPreEntryByGroupAndDate
from crm.views import abonement_freeze
from crm.views import visits
from allstars.swagger import schema_view
# from .views.reports.daily_revenue import DailyRevenueView
from django.contrib.auth.decorators import login_required

##### DELETE ON DEBUG ENVIRONMENT
from  django.views.defaults import page_not_found, permission_denied, server_error
######


urlpatterns = [
    path('', index.IndexView.as_view(), name='index'),
    path('login/', login.LoginView.as_view(), name='login'),
    path('logout/', logout.logout_view, name='logout'),

    path('tutors/list/', tutor.TutorViewList.as_view(), name='tutor_list'),
    path('tutors/create/', tutor.TutorCreateView.as_view(), name='tutor_create'),
    path('tutors/edit/<int:id>', tutor.TutorEditView.as_view(), name='tutor_edit'),
    path('tutors/delete/<int:id>', tutor.delete_tutor, name='tutor_delete'),
    #path('tutors/mass_delete/<int:id>',  name='tutor_mass_delete'),

    # client
    path('clients/list/', client.ClientViewList.as_view(), name='client_list'),
    path('clients/create/', client.ClientCreateView.as_view(), name='client_create'),
    path('clients/edit/<int:id>', client.ClientEditView.as_view(), name='client_edit'),
    path('clients/delete/<int:id>', client.delete_client, name='client_delete'),
    path('clients/search/', client.ClientSearchView.as_view(), name='search_clients'),

    # client information
    path('client/<int:client_id>/information/abonement', info_abonement.AbonementView.as_view(), name='client_info_detail'),
    path('client/<int:client_id>/information/abonement/<int:abon_id>/edit', info_abonement.AbonementEditView.as_view(), name='client_abonement_edit'),
    path('client/<int:client_id>/information/history/', info_history.HistoryView.as_view(), name='client_info_history'),
    path('client/<int:client_id>/information/info', InformationView.as_view(), name="client_info_information"),
    path('client/<int:client_id>/information/installments', installment.InstallmentView.as_view(), name="client_info_installment"),
    path('client/<int:client_id>/information/installment/<int:installment_id>/payments/list', InstallmentPaymentsView.as_view(), name="client_info_installment_payments"),
    path('client/<int:client_id>/information/installment/<int:installment_id>/payments/create', InstallmentPaymentsCreate.as_view(), name="client_info_create_payment_by_installment"),


    # promotion
    path('promo/list/', promotion.PromotionViewList.as_view(), name='promo_list'),
    path('promo/create/', promotion.PromotionCreateView.as_view(), name='promo_create'),
    path('promo/edit/<int:id>', promotion.PromotionEditView.as_view(), name='promo_edit'),
    path('promo/delete/<int:id>', promotion.promotion_delete, name='promo_delete'),

    # source of attraction
    path('sofa/list/', source_of_attraction.SofaViewList.as_view(), name='sofa_list'),
    path('sofa/create/', source_of_attraction.SofaCreateView.as_view(), name='sofa_create'),
    path('sofa/edit/<int:id>', source_of_attraction.SofaEditView.as_view(), name='sofa_edit'),
    path('sofa/delete/<int:id>', source_of_attraction.sofa_delete, name='sofa_delete'),

    # abonements
    path('abon/list/', abonement.AbonViewList.as_view(), name='abon_list'),
    path('abon/create/', abonement.AbonCreateView.as_view(), name='abon_create'),
    path('abon/edit/<int:id>', abonement.AbonEditView.as_view(), name='abon_edit'),
    path('abon/delete/<int:id>', abonement.abon_delete, name='abon_delete'),

    #sales
    path('sale/list/', sale.SaleViewList.as_view(), name='sale_list'),
    path('sale/create/', sale.SaleCreateView.as_view(), name='sale_create'),
    path('sale/edit/<int:id>', sale.SaleEditView.as_view(), name='sale_edit'),
    path('sale/massdelete/', sale.SaleDelete.as_view(), name='sale_mass_delete'),
    path('sale/delete/<int:sale_id>', sale.SaleDelete.as_view(), name='sale_delete'),
    path('sale/one_delete/<int:sale_id>', sale.sale_delete, name='one_sale_delete'),
    path('sale/search/', sale.CashboxSearchView.as_view(), name='search_cashbox'),

    # REVOKE SALE
    path('sale/<int:abon_id>/revoke', revoke_abonement.RevokeAbonementAjaxView.as_view(), name='revoke_sale_abon'),

    # FREEZE SALE
    path('sale/freeze', abonement_freeze.AbonementFreeze.as_view(), name='freeze_sale'),

    # groups
    path('groups/list/', group.GroupViewList.as_view(), name='group_list'),
    path('groups/create/', group.GroupCreateView.as_view(), name='group_create'),
    path('groups/edit/<int:id>', group.GroupEditView.as_view(), name='group_edit'),
    path('groups/delete/<int:id>', group.delete_group, name='group_delete'),
    #path('groups/mass_delete/<int:id>',  name='tutor_mass_delete'),


    # SETTINGS
    ## RBAC
    ### USER
    path('settings/rbac/users/list/', users.UserViewList.as_view(), name='user_setting_list'),
    path('settings/rbac/users/create/', users.UserCreateView.as_view(), name='user_setting_create'),
    path('settings/rbac/users/edit/<int:id>', users.UserEditView.as_view(), name='user_setting_edit'),
    path('settings/rbac/users/delete/<int:id>', users.delete_user, name='user_setting_delete'),
    path('settings/rbac/users/mass_delete/', users.mass_user_delete, name='mass_delete_user'),

    ### GROUPS
    path('settings/rbac/groups/list/', groups.GroupView.as_view(), name='group_settings_list'),
    path('settings/rbac/groups/create/', groups.GroupCreateView.as_view(), name='group_settings_create'),




    path('settings/departaments/list/', departaments.DepartamentViewList.as_view(), name='departament_setting_list'),
    path('settings/departaments/create/', departaments.DepartamentCreateView.as_view(), name='departament_setting_create'),
    path('settings/departaments/edit/<int:id>', departaments.DepartamentEditView.as_view(), name='departament_setting_edit'),
    path('settings/departaments/delete/<int:id>', departaments.delete_departament, name='departament_setting_delete'),
    #path('settings/departaments/mass_delete/<int:id>')

    # Installments

    # path('installments/list',  installments.InstallmentViewList.as_view(), name='installment_list'),
    # path('installments/create',  installments.InstallmentCreateView.as_view(), name='installment_create'),
    #
    # path('installments/payments/list', payments.PaymentViewList.as_view(), name='payments_by_installment_list'),
    # path('installments/<int:id>/payments/create', payments.PaymentCreateView.as_view(), name='payments_by_installment_create'),
    


    # AJAX DATA


    # SALES
    path('ajax/sales/last_abon/<int:client_id>', sale.AjaxGetLastSoldAbon.as_view(), name='ajax_last_abon'),
    path('ajax/sales/last_promotion/<int:client_id>', sale.AjaxGetLastSoldPromotion.as_view(), name='ajax_last_promo'),
    path('ajax/sales/groups_by_tutor/', sale.AjaxGroupsByTutorView.as_view(), name='ajax_groups_by_tutor'),
    path('ajax/sales/get_abonement', abonement.AjaxAbonementByGroupView.as_view(), name='ajax_get_abonement'),
    path('ajax/sales/get_one_time_abonement', abonement.AjaxOneTimeVisitAbonementByGroupView.as_view(), name='ajax_get_one_time_abonement'),
    path('ajax/sales/get_price/<int:abon_id>', abonement.AjaxGetAbonementPrice.as_view(), name='ajax_get_full_price'),
    path('ajax/sales/get_discount/', sale.AjaxGetDiscount.as_view(), name='ajax_get_discount'),
    path('ajax/sales/today/', index.AjaxSalesToday.as_view(), name='ajax_get_sale_today'),
    path('ajax/sales/yesterday/', index.AjaxSaleYersterday.as_view(), name='ajax_get_sale_yesterday'),
    path('ajax/sales/month/', index.AjaxSaleMonth.as_view(), name='ajax_get_sale_month'),
    path('ajax/client/new/today/', client.AjaxGetNewClients.as_view(), name='ajax_get_new_client_today'),
    path('ajax/sales/get_abonement_id_by_sale_id/', sale.AjaxGetAbonementIdBySale.as_view(), name='ajax_get_abon_id_by_sale_id'),
    path('ajax/sales/delete_revoke/', sale.AjaxDeleteRevoke.as_view(), name='ajax_delete_revoke'),
    path('ajax/sales/get_groups/', sale.AjaxGetGroupsBySale.as_view(), name='ajax_groups_by_sale'),

    # USER CHANGE PASSWORD
    path('ajax/user/change_password/', users.AjaxUpdateUserPassword.as_view(), name='ajax_update_user_password'),

    # CLIENT INFORAMTION

reports/urls.py
from .views.cashbox import CashboxView, StartReportView
from .views.incoming_money import IncomingMoneyView, StartIncomingMoneyReportView
from .views.incoming_money_detail import IncomingMoneyDetailView

# PROMO DISCOUNT
from .views.promo_discount import PromoDiscountView, StartPromoDiscountReportView, PromoDiscountDetailView

# ACTIVE CLIENTS
from .views.active_clients import ActiveClientReportView, StartActiveClientReportView
from .views.active_clients_detail import ActiveClientsDetailView

# CLIENTS DEBT
from .views.clients_debt import view as clientdebtview
from .views.clients_debt import detail as clientdebtdetail

# SALES BY GROUPS
from .views.sales_by_groups import view as salesbygroupview
from .views.sales_by_groups import detail as salesbygroupdetail

# SALES TO GROUP
from .views.sales_to_groups import view as salestogroupview
from .views.sales_to_groups import detail as salestogroupdetail


from django.urls import path

app_name = 'reports'

urlpatterns = [
    path('cashbox/', CashboxView.as_view(), name="cashbox_report"),
    path('cashbox/start_report/', StartReportView.as_view(), name="cashbox_make_report"),
    path('incoming_money/', IncomingMoneyView.as_view(), name="incoming_money_report"),
    path('incoming_money/start_report/', StartIncomingMoneyReportView.as_view(), name="make_incoming_report"),
    path('incoming_money/detail/<int:id>/', IncomingMoneyDetailView.as_view(), name="incoming_money_report_detail"),

    # PROMO AND DISCOUNT
    path('promo_discount/', PromoDiscountView.as_view(), name="promo_discount_report"),
    path('promo_discount/start_report/', StartPromoDiscountReportView.as_view(), name="make_promo_discount_report"),
    path('promo_discount/detail/<int:id>/', PromoDiscountDetailView.as_view(), name="promo_discount_report_detail"),

    # ACTIVE CLIENTS
    path('active_clients/', ActiveClientReportView.as_view(), name="active_client_report"),
    path('active_clients/start_report/', StartActiveClientReportView.as_view(), name="active_client_report_start"),
    path('active_clients/detail/<int:id>/', ActiveClientsDetailView.as_view(), name="active_clients_report_detail"),

    # CLIENTS DEBT
    path('clients_debt/', clientdebtview.ReportView.as_view(), name="clients_debt_report_view"),
    path('clients_debt/start_report/', clientdebtview.StartReport.as_view(), name="clients_debt_report_start"),
    path('clients_debt/detail/<int:id>/', clientdebtdetail.ReportDetailView.as_view(), name="clients_debt_report_detail"),

    # SALES BY GROUPS
    path('sales_by_groups/', salesbygroupview.ReportView.as_view(), name="sales_by_groups_report_view"),
    path('sales_by_groups/start/report', salesbygroupview.StartReport.as_view(), name="sales_by_groups_report_start"),
    path('sales_by_groups/detail/<int:id>/', salesbygroupdetail.ReportDetailView.as_view(), name="sales_by_groups_report_detail"),

    # SALES TO GROUP
    path('sales_to_groups/', salestogroupview.ReportView.as_view(), name="sales_to_groups_report_view"),
    path('sales_to_groups/start/report', salestogroupview.StartReport.as_view(), name="sales_to_groups_report_start"),
    path('sales_to_groups/detail/<int:id>/', salestogroupdetail.ReportDetailView.as_view(), name="sales_to_groups_report_detail"),

]

reports/forms/active_clients.py
from .cashbox import CashboxForm


class ActiveClientsForm(CashboxForm):
    pass

reports/forms/cashbox.py
from django import forms
from reports.models import CashboxReport
from crm.models import Departament
import datetime
from crm.utils.forms import make_dynamic_choice_field



class CashboxForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        # first call parent's constructor
        super().__init__(*args, **kwargs)
        # there's a `fields` property now
        self.fields['date_to'].required = False
        self.fields['date_from'].required = False
        self.fields['current_day'].required = False

    REPORT_CHOICES = [
        ('DAY', 'День'),
        ('MONTH', 'Месяц'),
        ('YEAR', 'Год'),
        ('CUSTOM', 'Произвольный период')
    ]

    MONTH_PARAMETERS = [
        ('CURRENT', 'Текущий месяц'),
        ('PREVIOUS', 'Прошлый месяц')
    ]

    YEAR_PARAMETERS = [
        ('CURRENT', 'Текущий Год'),
        ('PREVIOUS', 'Прошлый Год')
    ]

    choice_period = forms.ChoiceField(label="Период",
                                      choices=REPORT_CHOICES,
                                      widget=forms.Select())


    departament_choice = forms.ModelChoiceField(label='Филиал',
                                                queryset=Departament.objects_default.all(),
                                                widget=forms.Select(),
                                                )


    current_day = forms.DateField(label='Выбор дня', widget=forms.DateInput(
        format='%d.%m.%Y',
        attrs={
            "data-date-format": "dd.mm.yyyy",
        }
    ))

    month_parameters = forms.ChoiceField(
        label="Параметры",
        choices=MONTH_PARAMETERS,
        widget=forms.Select()
    )

    year_parameters = forms.ChoiceField(
        label="Параметры",
        choices=YEAR_PARAMETERS,
        widget=forms.Select()
    )

    class Meta:
        model = CashboxReport
        fields = ['departament_choice', 'choice_period', 'date_to', 'date_from']
        labels = {
            "departament_choice": "Филиал",
            "date_to": 'Дата c',
            "date_from": 'Дата по',
        }
        widgets = {
            'date_to': forms.DateInput(format='%d.%m.%Y', attrs={
                "data-date-format": "dd.mm.yyyy"
            }),

            'date_from': forms.DateInput(format='%d.%m.%Y', attrs={
                "data-date-format": "dd.mm.yyyy"
            })
        }



reports/views/active_clients.py
from .base import BaseStartReport, BaseReportView
from reports.forms.active_clients import ActiveClientsForm
from reports.models import ActiveClientsReport
import datetime
from reports.tasks import make_report_active_clients


class ActiveClientReportView(BaseReportView):
    template_name = 'reports/active_clients.html'
    create_form = ActiveClientsForm
    heading = 'Отчет Активные клиенты'
    queryset = ActiveClientsReport.report_objects.all()


class StartActiveClientReportView(BaseStartReport):
    form_class = ActiveClientsForm
    template_name = 'reports/active_clients.html'


    def run_task_departament_all(self, date_to, date_from):
        make_report_active_clients(
            period_info=self.period_context.get_period(),
            date_from=date_from,
            date_to=date_to,
            user_id=self.request.user.id
        )  # DELETE DELAY ITS TEMPORARY FIX, NEED REVIEW CELERY TASK

    def run_task_concrete_departament(self, date_to, date_from, departament_id):
        make_report_active_clients(
            period_info=self.period_context.get_period(),
            date_from=datetime.datetime.combine(date_from, datetime.time.min),
            date_to=datetime.datetime.combine(date_to, datetime.time.max),
            user_id=self.request.user.id,
            departament_id=departament_id
        )

reports/views/active_clients_detail.py
from crm.mixins import LoginMixin
from django.views.generic import ListView
from reports.models import ActiveClientsReportData


class ActiveClientsDetailView(LoginMixin, ListView):
    template_name = 'reports/active_clients_detail.html'

    def get_queryset(self):
        report_id = self.kwargs.get('id')
        return ActiveClientsReportData.objects.filter(report_id=report_id).all()

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data(**kwargs)
        context['report_data'] = self.get_queryset()
        return context

templates/reports/sales_by_groups/detail.html
{% extends 'reports/base.html' %}
{% load crm_utils %}

{% load static %}
{% block content %}


    {% block page_heading %}{% endblock %}
        <div class="container-fluid">
        <div class="card shadow mb-4">
            <div class="card-header py-3">
              <h6 class="m-0 font-weight-bold text-primary"></h6>
            </div>
            <div class="card-body">
              <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                  <thead>
                    <tr>
                      <th>Абонемент</th>
                      <th>Продолжительность абонемента</th>
                      <th>Количество проданных</th>
                      <th>Количество доплат</th>
                      <th>Доход</th>
                    </tr>
                  </thead>
                  <tbody>
                  <div class="total-info">
                      <div class="abon-count">
                          <h5>Общее количество проданных абонементов {{ total_data.total_sales_abon_count }}</h5>
                      </div>

                      <div class="count-payments">
                          <h5>Общее количество доплат {{ total_data.total_count_payments }}</h5>
                      </div>

                      <div class="total-sum">
                          <h5>Общая сумма {{ total_data.total_sum }}</h5>
                      </div>
                  </div>
                  {% for data in report_data %}
                      <tr>
                        <td>{{ data.abonement }}</td>
                        <td>{{ data.duration }}</td>
                        <td>{{ data.sales_count }}</td>
                        <td>{{ data.count_payment_by_installment }}</td>
                        <td>{{ data.income_money }}</td>
                      </tr>
                      {% empty %}
                        {% include 'no_data.html' %}
                  {% endfor %}
                  </tbody>
                </table>

        </div>


{% endblock %}

{% block custom_includes %}
    {{ block.super }}
{% endblock %}

templates/reports/sales_by_groups/index.html
{% extends 'reports/base.html' %}
{% load crm_utils %}

{% load static %}
{% block content %}

    {% block page_heading %}
        <div class="container-fluid">
            <div class="d-sm-flex flex-column">
                <div class="row">
                    <div class="col page-header">
                        <h1 class="h3 text-center text-md-left  mb-0 text-gray-800">{{ heading }}</h1>
                    </div>
                    <div class="col-md-2">
                        <div class="page-actions">
                            <button class="btn btn-success mr-4 mb-2" data-toggle="modal" data-target="#salesByGroupCreate">Создать отчет</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        {% include 'utils/page_actions/create_report_cashbox_modal.html' with modal_id="salesByGroupCreate" modal_title="Создать отчет Продажи по группам" form=create_form action_url="reports:sales_by_groups_report_start"|reverso %}
        {% endblock %}
        <div class="container-fluid">
        <div class="card shadow mb-4">
            <div class="card-header py-3">
              <h6 class="m-0 font-weight-bold text-primary"></h6>
            </div>
            <div class="card-body">
              <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                  <thead>
                    <tr>
                      <th>Дата создания отчета</th>
                      <th>Пользователь</th>
                      <th>Филиал</th>
                      <th>Дата с</th>
                      <th>Дата по</th>
                      <th>Действия</th>

                    </tr>
                  </thead>
                  <tbody>
                  {% for data in report_data %}
                      <tr>
                        <td>{{ data.created }}</td>
                        <td>{{ data.user }}</td>
                        <td>
                            {% if data.departament == None %}
                                <p>Все</p>
                            {% else %}
                                {{ data.departament }}
                            {% endif %}
                        </td>
                      <td>{{ data.date_to }}</td>
                        <td>{{ data.date_from }}</td>

                        <td>
                            <a href="{% url 'reports:sales_by_groups_report_detail' data.id %}">
                                <i class="fa fa-eye"></i>
                            </a>
                        </td>
                      </tr>
                  {% endfor %}

                  </tbody>
                </table>

        </div>

                <style>
                    .page-actions {
                        display: flex;
                        justify-content: flex-end;
                    }
                </style>

    <script type="application/javascript">
    $(document).ready(function () {
        $('#id_date_to').datepicker({
        autoclose: true,
        todayHighlight: true,
    });
        $('#id_date_from').datepicker({
        autoclose: true,
        todayHighlight: true,
    });
        $('#id_current_day').datepicker({
        autoclose: true,
        todayHighlight: true,
        weekStart: 1,
        startView: 1,
        maxViewMode: 1,
    });
    })
    </script>

{% endblock %}

{% block custom_includes %}
    {{ block.super }}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.7.1/css/bootstrap-datepicker.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.7.1/js/bootstrap-datepicker.min.js"></script>


{% endblock %}